#ifndef __KERNEL_HEADER_INCLUDED__
#define __KERNEL_HEADER_INCLUDED__

#include <arch/types.h>
#include <arch/processor.h>
#include <arch/io.h>

/* GCC extensions */
#define __init		__attribute__ ((__section__ (".text.init")))
#define __initdata	__attribute__ ((__section__ (".data.init")))
#define __init_call	__attribute__ ((unused,__section__ (".initcall.init")))
#define __noreturn	__attribute__ ((noreturn))

/* Required constants */
#define INT_MAX		((int)(~0U>>1))
#define INT_MIN		(-INT_MAX - 1)
#define UINT_MAX	(~0U)
#define NULL ((void *)0)

/* Kernel types */
typedef u_int32_t pid_t;
typedef u_int32_t block_t;

/* Common kernel API stuff */
void printk(const char *, ...);

/* Driver initialisation */
#define driver_init(fn) __initcall(fn)
typedef void (*initcall_t)(void);
extern initcall_t __initcall_start,__initcall_end;
#define __initcall(fn) \
	static initcall_t __initcall_##fn __init_call = fn

#endif /* __KERNEL_HEADER_INCLUDED__ */
